package ru.dbotthepony.mc.otm.block.entity

import net.minecraft.network.chat.Component
import ru.dbotthepony.mc.otm.core.TranslatableComponent

enum class RedstoneSetting(val label: Component, val description: Component) {
	IGNORED(TranslatableComponent("otm.gui.redstone.ignored"), TranslatableComponent("otm.gui.redstone.ignored.description")),
	LOW(TranslatableComponent("otm.gui.redstone.low"), TranslatableComponent("otm.gui.redstone.low.description")),
	HIGH(TranslatableComponent("otm.gui.redstone.high"), TranslatableComponent("otm.gui.redstone.high.description"));

	operator fun next(): RedstoneSetting {
		return values[(ordinal + 1) % values.size]
	}

	companion object {
		private val values = values()

		@JvmStatic
		operator fun get(index: Int): RedstoneSetting {
			if (index !in 0 .. 2)
				return LOW

			return values[index]
		}
	}
}