package ru.dbotthepony.mc.otm.client.screen.panels

import com.mojang.blaze3d.vertex.PoseStack
import ru.dbotthepony.mc.otm.client.render.StretchingRectangleElement
import ru.dbotthepony.mc.otm.client.render.WidgetLocation
import ru.dbotthepony.mc.otm.client.render.element
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen

open class BackgroundPanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel?,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = 10f,
	height: Float = 10f,
) : EditablePanel(screen, parent, x, y, width, height) {
	init {
		dockPadding = DockProperty(3f, 3f, 3f, 3f)
	}

	override fun innerRender(stack: PoseStack, mouseX: Float, mouseY: Float, partialTick: Float) {
		RECTANGLE.render(stack, width = width, height = height)
	}

	companion object {
		fun padded(
			screen: MatteryScreen<*>,
			parent: EditablePanel?,
			x: Float = 0f,
			y: Float = 0f,
			width: Float = 10f,
			height: Float = 10f,
		) = BackgroundPanel(screen, parent, x, y, width + 6f, height + 6f)

		fun paddedCenter(
			screen: MatteryScreen<*>,
			parent: EditablePanel?,
			x: Float = 0f,
			y: Float = 0f,
			width: Float = 10f,
			height: Float = 10f,
		) = BackgroundPanel(screen, parent, x - 3f, y - 3f, width + 6f, height + 6f)

		val RECTANGLE = StretchingRectangleElement(
			topLeft = WidgetLocation.WIDGETS.element(18f, 24f, 3f, 3f),
			topRight = WidgetLocation.WIDGETS.element(27f, 24f, 3f, 3f),
			bottomLeft = WidgetLocation.WIDGETS.element(18f, 33f, 3f, 3f),
			bottomRight = WidgetLocation.WIDGETS.element(27f, 33f, 3f, 3f),
			top = WidgetLocation.WIDGETS.element(21f, 24f, 6f, 2f),
			bottom = WidgetLocation.WIDGETS.element(21f, 34f, 6f, 2f),
			left = WidgetLocation.WIDGETS.element(18f, 27f, 2f, 6f),
			right = WidgetLocation.WIDGETS.element(28f, 27f, 2f, 6f),
			middle = WidgetLocation.WIDGETS.element(30f, 12f, 6f, 6f),
			padding = DockProperty(-1f, -1f, -1f, -1f)
		)
	}
}
