package ru.dbotthepony.mc.otm.client.screen.widget

import com.mojang.blaze3d.vertex.PoseStack
import ru.dbotthepony.mc.otm.client.render.UVWindingOrder
import ru.dbotthepony.mc.otm.client.render.WidgetLocation
import ru.dbotthepony.mc.otm.client.render.element
import ru.dbotthepony.mc.otm.client.screen.MatteryScreen
import ru.dbotthepony.mc.otm.client.screen.panels.EditablePanel
import ru.dbotthepony.mc.otm.menu.widget.LevelGaugeWidget

open class HorizontalPowerGaugePanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel? = null,
	widget: LevelGaugeWidget,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = GAUGE_BACKGROUND.w,
	height: Float = GAUGE_BACKGROUND.h
) : PowerGaugePanel(screen, parent, widget, x, y, width, height) {
	var flop = false

	override fun innerRender(stack: PoseStack, mouseX: Float, mouseY: Float, partialTick: Float) {
		if (height >= 18f) {
			if (flop) {
				GAUGE_BACKGROUND_TALL.render(stack, height = height, width = this.width, winding = UVWindingOrder.U1_V0_U0_V1)
				val width = this.width * widget.percentage()
				GAUGE_FOREGROUND_TALL.renderPartial(stack, x = this.width - width, height = height, width = width, winding = UVWindingOrder.U1_V0_U0_V1)
			} else {
				GAUGE_BACKGROUND_TALL.render(stack, height = height, width = this.width)
				val width = this.width * widget.percentage()
				GAUGE_FOREGROUND_TALL.renderPartial(stack, height = height, width = width)
			}
		} else {
			if (flop) {
				GAUGE_BACKGROUND.render(stack, height = height, width = this.width, winding = UVWindingOrder.U1_V0_U0_V1)
				val width = this.width * widget.percentage()
				GAUGE_FOREGROUND.renderPartial(stack, x = this.width - width, height = height, width = width, winding = UVWindingOrder.U1_V0_U0_V1)
			} else {
				GAUGE_BACKGROUND.render(stack, height = height, width = this.width)
				val width = this.width * widget.percentage()
				GAUGE_FOREGROUND.renderPartial(stack, height = height, width = width)
			}
		}
	}

	companion object {
		val GAUGE_BACKGROUND = WidgetLocation.WIDGETS.element(x = 160f, y = 238f, w = 96f, h = 9f)
		val GAUGE_FOREGROUND = WidgetLocation.WIDGETS.element(x = 160f, y = 247f, w = 96f, h = 9f)

		val GAUGE_BACKGROUND_TALL = WidgetLocation.WIDGETS.element(x = 160f, y = 202f, w = 96f, h = 18f)
		val GAUGE_FOREGROUND_TALL = WidgetLocation.WIDGETS.element(x = 160f, y = 220f, w = 96f, h = 18f)
	}
}

/**
 * Shortcut to [HorizontalPowerGaugePanel] with doubled height
 */
fun TallHorizontalPowerGaugePanel(
	screen: MatteryScreen<*>,
	parent: EditablePanel? = null,
	widget: LevelGaugeWidget,
	x: Float = 0f,
	y: Float = 0f,
	width: Float = HorizontalPowerGaugePanel.GAUGE_BACKGROUND_TALL.w,
	height: Float = HorizontalPowerGaugePanel.GAUGE_BACKGROUND_TALL.h
) = HorizontalPowerGaugePanel(screen, parent, widget, x, y, width, height)
