package ru.dbotthepony.mc.otm.tests

import it.unimi.dsi.fastutil.io.FastByteArrayInputStream
import it.unimi.dsi.fastutil.io.FastByteArrayOutputStream
import org.junit.jupiter.api.Assertions.assertEquals
import org.junit.jupiter.api.DisplayName
import org.junit.jupiter.api.Test
import ru.dbotthepony.mc.otm.core.readInt
import ru.dbotthepony.mc.otm.core.readVarIntLE
import ru.dbotthepony.mc.otm.core.writeInt
import ru.dbotthepony.mc.otm.core.writeVarIntLE

object FriendlyStreams {
	@Test
	@DisplayName("Stream extension functions")
	fun test() {
		val output = FastByteArrayOutputStream()

		output.writeInt(4)
		output.writeInt(16)
		output.writeInt(-1)
		output.writeInt(1000000)

		output.writeVarIntLE(0)
		output.writeVarIntLE(1)
		output.writeVarIntLE(4)
		output.writeVarIntLE(15)
		output.writeVarIntLE(16)
		output.writeVarIntLE(127)
		output.writeVarIntLE(128)
		output.writeVarIntLE(129)
		output.writeVarIntLE(10023)
		output.writeVarIntLE(100000)

		val input = FastByteArrayInputStream(output.array, 0, output.length)

		assertEquals(input.readInt(), 4)
		assertEquals(input.readInt(), 16)
		assertEquals(input.readInt(), -1)
		assertEquals(input.readInt(), 1000000)

		assertEquals(input.readVarIntLE(), 0)
		assertEquals(input.readVarIntLE(), 1)
		assertEquals(input.readVarIntLE(), 4)
		assertEquals(input.readVarIntLE(), 15)
		assertEquals(input.readVarIntLE(), 16)
		assertEquals(input.readVarIntLE(), 127)
		assertEquals(input.readVarIntLE(), 128)
		assertEquals(input.readVarIntLE(), 129)
		assertEquals(input.readVarIntLE(), 10023)
		assertEquals(input.readVarIntLE(), 100000)
	}
}